jQuery.fn.River = function (settings) {
    settings = jQuery.extend({
      speed: 50,
  		pause: false,
  		buttons: false,
      direction: "right",
      loop:true,
      backto:"index.html"
    }, settings);

    return this.each(function(){
  		var j = jQuery;
      var $line = j(this);　// 指定要素ulを$line にセット
      var currentSpazio,currentTempo,scrollDirection;  // 変数の初期化
      var run = true;
	    var lineWidth = 1;

      $line.children("li.tick-clones").remove();
//    $line.addClass("imageticker");
      var $mask = $line.wrap("<div class='mask'></div>");　// 指定要素ul を <div class="mask">で括る
      var $tickercontainer = $line.parent().wrap("<div class='tickercontainer'></div>"); // 指定要素ul の親要素（つまり <div class="mask">）をさらに<div class='tickercontainer'>で括る
		  var elements = $line.children("li");　// elements に指定要素ulの子要素liを設定
      var elementsNum = elements.length;　// liの個数をelementsNumに格納

      // 関数　fill()を設定
		  var fill = function(){
  			lineWidth = 1;　// lineWidth を 1 に設定
  			$line.append(elements.clone(true).addClass("tick-clones")); // li のクローンをつくり、そのクローンにclass="tick-clones"を設定
  			$line.children("li").each(function (i) {
  				lineWidth += j(this, i).outerWidth(true);　// lineWidth に（ 1+liの幅）
  				//true値をもつoutherWidthはマージンを含む幅を返す
  			});
  		};

      //設定された画像だけでは画面幅を満たさない場合の処理
  		var l = $tickercontainer.outerWidth(true);　//<div class='tickercontainer'>(画面幅)の外寸をセット
  		while(lineWidth<l){
        fill(); 　// lineWidthが画面幅より小さいときは、関数(fill)を実行
      }

// 関数　scrollImages() の定義
    function scrollImages(spazio, tempo, direction){
      var showCredit = false;
      if(direction == "left"){　//左に流れる場合
        $line.animate({left: '-=' + spazio}, tempo, "linear", function () {　 //指定要素ulを　アニメーションで 位置（left/right 第一引数 -spazio） まで 速さ　（第二引数tempo） で　
              for(i = 0; i < elementsNum; i++){
                $line.children("li:first").appendTo($line);　//それが終了すると 指定要素ul の最初の子要素liを、ulの最後の子要素の後ろに追加
              }
              if(run){　// loopする場合
                $line.css("left", 0);　//指定要素ul の位置をleft:0にセット
              	scrollImages(currentSpazio, currentTempo, scrollDirection);　//関数 scrollImages(); を実行
              }else{　// loopしない場合
                endRoll();
            }
        });
      }else{　//右に流れる場合
        $line.animate({right: '-=' + spazio}, tempo, "linear", function () {　 //指定要素ulを　アニメーションで 位置（left/right 第一引数 -spazio） まで 速さ　（第二引数tempo） で　
            for(i = 0; i < elementsNum; i++){
              $line.children("li:first").appendTo($line);　//それが終了すると 指定要素ul の最初の子要素liを、ulの最後の子要素の後ろに追加
            }
            if(run){　// loopする場合
              $line.css("right", 0);　//指定要素ul の位置をright:0にセット
            	scrollImages(currentSpazio, currentTempo, scrollDirection);　　//関数 scrollImages(); を実行
            }else{　// loopしない場合
              endRoll();
            }
        });
      }

      // フルスクリーン解除時
      window.addEventListener('resize', function (){
        if(!checkFullScreen() && showCredit == false){
          endRoll(true);
        }
      });

      function endRoll(escape){
        if(escape == true){
          $('.start').stop(true,true).hide();
          if($('.note').length){
            $('.note').stop(true,true).hide();
          }
          $line.stop(true,true).fadeOut(3000);
        }else{
          $line.stop(true,true).fadeOut(3000);
        }
        if($('h3').length){　
          $('h3').fadeIn(3000).delay(2000).fadeOut(2000);
        }
        showCredit = true;
        setTimeout(function(){
          window.location.href = settings.backto;
          return false;
        }, 7000);
      }
       function checkFullScreen() {
         var fullscreen_flag = false;
         if(document.fullscreenElement || document.mozFullscreenElement || document.webkitFullscreenElement || document.msFullscreenElement) {
           fullscreen_flag = true;
         }
         return fullscreen_flag;
       }
    }

// BOOT　起動
//    currentSpazio = $line.children("li:first").outerWidth(true); // 初期値　指定ul の最初の子要素liの外寸をcurrentSpazioにセット
    var w = screen.height;
    var sw = screen.width;
    run = settings.loop;
    if(run){
      currentSpazio = w * elementsNum; //loopの場合はなめらかに最初のコマが戻ってくるように
    }else{
      currentSpazio = w * elementsNum - sw;　//loopしない場合は最後のコマで止まるように
    }
    currentTempo = settings.speed * 1000 * elementsNum;　// liの個数*スピード(ms)をスピードに設定　= ul全体を何msで端まで移動させるか
    scrollDirection = settings.direction;
    scrollImages(currentSpazio, currentTempo, scrollDirection);　// この設定値で関数scrollImagesを起動
    });
};
